//+------------------------------------------------------------------+
//|                                                         Sova.mq4 |
//+------------------------------------------------------------------+
extern int MATrendPeriod=13;
extern double MACDOpenLevel=0;
extern int TakeProfit=100;
extern double Lots=0.1;

string lSymbol;
int init(){lSymbol=Symbol(); return(0);}
int deinit(){return(0);}
int start() 
{ if(TakeProfit<10)
   {Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
   }
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, MaCurrent, MaPrevious,bid,ask,point,digits;
   int cnt, ticket, total,nnnn;

   total=OrdersTotal();
   if(total<1) 
   {  bid   = MarketInfo(lSymbol,MODE_BID);
      ask   = MarketInfo(lSymbol,MODE_ASK);
      point = MarketInfo(lSymbol,MODE_POINT);
      digits= MarketInfo(lSymbol,MODE_DIGITS);
   
      // to simplify the coding and speed up access
      // data are put into internal variables
   
      MacdCurrent    = iMACD(lSymbol, 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN,0);
      MacdPrevious   = iMACD(lSymbol, 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN,1);
      SignalCurrent  = iMACD(lSymbol, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL,0);
      SignalPrevious = iMACD(lSymbol, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL,1);
      
      MaCurrent      = iMA(  lSymbol, 0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
      MaPrevious     = iMA(  lSymbol, 0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
      {Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
      }
      // check for long position (BUY) possibility
      if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious && MathAbs(MacdCurrent)>(MACDOpenLevel*point) && MaCurrent>MaPrevious)
      { ticket=OrderSend(lSymbol,OP_BUY,Lots,ask,3,0,ask+TakeProfit*point,"macd sample",16384,0,Green);
         if(ticket>0)
         { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice()," as ", lSymbol);
         }
         else Print("Error opening BUY order : ",GetLastError()," as ", lSymbol); 
         return(0); 
      }
      // check for short position (SELL) possibility
      if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious &&  MacdCurrent>(MACDOpenLevel*point) && MaCurrent<MaPrevious)
      {ticket=OrderSend(lSymbol,OP_SELL,Lots,bid,3,0,bid-TakeProfit*point,"macd sample",16384,0,Red);
         if(ticket>0)
         {if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice()," bid ", lSymbol);
         }
         else Print("Error opening SELL order : ",GetLastError()," bid ", lSymbol);
         return(0); 
      }
   }
   return(0);}
//+------------------------------------------------------------------+